/***************************************************************************
                          icets.h  -  description
                             -------------------
    begin                :    4 21:07:08 EET 2002
    copyright            : (C) 2002 by Vadim A. Khohlov
    email                : xvadim@teko.kherson.ua
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ICETS_H
#define ICETS_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qstring.h>

class QListView;
class QListViewItem;
class QLabel;

class QPreviewWidget;
/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class IcetsView is
  * created which creates your view.
  */
class IcetsApp : public QWidget//QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    IcetsApp();
    /** destructor */
    ~IcetsApp();

private: // Private attributes
  /**  */
  QListView *lvThemesTree;
  /**  */
  QPreviewWidget *previewWidget;
  /**  */
  QLabel *lbAuthor;
  /**  */
  QLabel *lbDescription;
  /** 
   * The directory's name of global themes.
   */
  QString globalDirName;
  /**
   * The directory's name of local themes.
   */
  QString localDirName;
  QString bigDescription;
  QString XBA;
  QString icetsDescription;
  /**  */
  QLabel *previewLabel;
  /** Private directory with IceWM's configs.
   */
  QString icewmCfgDir;
private: // Private methods
  /** 
   * Loads themes into lvThemesTree
   */
  void loadThemes();
  /** No descriptions */
  void loadSubTreeThemes(QListViewItem *rootItem, const QString themeType);
  /** 
   * Returns theme's directory.
   */
  QString getThemesDir(QListViewItem *item);
  /**
   * Show theme's info into lbAuthor and lbDescription.
   */
  void showThemeInfo(const QString &themeFileName);
private slots: // Private slots
  /** No descriptions */
  void slotThemeSelected(QListViewItem *newItem);
  /**
   * Writes into preferences new theme and restarts IceWM fo
   * aplying changes.
   */
  void setTheme();
  /** No descriptions */
  void slotOk();
};
#endif 

